import java.util.LinkedList;
/**
 * Clase que te el cos d'un missatge i les funcions que es poden fer sobre ell
 * @author LUIS
 *
 */

public class missatge {
	/* Variables de inici */
	private int font;
	private int desti;
	private String missatge;
	private int distancia;
	private LinkedList recorregut = new LinkedList();
	/*si true ja ha contat com a origen*/
	private boolean hepasat=false;
	/**
	 * Constructor de la clase missatge
	 * @param font
	 * @param desti
	 * @param missatge
	 */
	public missatge(int font, int desti, String missatge) {
		this.font = font;
		this.desti = desti;
		this.missatge = missatge;
	}
	/**
	 * Funcio que retorna l'identificador de desti que te el missatge
	 * @return int
	 */
	public int getDesti() {
		return desti;
	}
	/**
	 * Funcio que actualitza l'identificador de desti que te el missatge
	 * @param desti
	 */
	public void setDesti(int desti) {
		this.desti = desti;
	}
	/**
	 * Funcio que retorna l'identificador font que te el missatge
	 * @return int
	 */
	public int getFont() {
		return font;
	}
	/**
	 * Funcio que actualitza l'identificador font que te el missatge
	 * @param font
	 */
	public void setFont(int font) {
		this.font = font;
	}
	/**
	 * Funcio que retorna el missatge que te el missatge
	 * @return String
	 */
	public String getMissatge() {
		return missatge;
	}
	/**
	 * Funcio que actualitza el missatge que te el missatge
	 * @param missatge
	 */
	public void setMissatge(String missatge) {
		this.missatge = missatge;
	}
	/**
	 * Funcio que retorna la deistancia que te el missatge
	 * @return int
	 */
	public int getDistancia() {
		return distancia;
	}
	/**
	 * Funcio que actualitza la distancia que te el missatge
	 * @param distancia
	 */
	public void setDistancia(int distancia) {
		this.distancia = distancia;
	}
	/**
	 * Funcio que retorna el recorregut que porta el missatge
	 * @return LinkedList
	 */
	public LinkedList getRecorregut() {
		return recorregut;
	}

	/**
	 * Funcio que afegeix l'identificador del node a la taula de recorregut que te el missatge
	 * @param o
	 */
	@SuppressWarnings("unchecked")
	public void addRecorregut(int o) {
		this.recorregut.add(o);
	}
	/**
	 * Funcio que diu si el missatge ha pasat per un node 
	 * @return boolean
	 */
	public boolean isHepasat() {
		return hepasat;
	}
	/**
	 * Funcio que actualitza la variable hepasat
	 * @param hepasat
	 */
	public void setHepasat(boolean hepasat) {
		this.hepasat = hepasat;
	}
	
	
}
